 

#include <sstream>
#include "MyCollector_t.hh"

// ////////////////////////////////////////////////////////////////
// Constructor and destructor.
// ////////////////////////////////////////////////////////////////
struct Payload_t
{
  int id;			
  double sender_times;       
  int Temperature;			 
};
MyCollector_t::MyCollector_t( const sc_core::sc_module_name modulename,
                    const task_id_t id,
                    Scnsl::Core::Node_t * n,
                    const size_t proxies )
    throw ():
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )


{
  
 
}


MyCollector_t::~MyCollector_t()
    throw ()
{
    // Nothing to do.
}

// ////////////////////////////////////////////////////////////////
// Inherited interface methods.
// ////////////////////////////////////////////////////////////////


void MyCollector_t::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t )
{
	Payload_t *temp=NULL; 
	if( p.get_command() == Scnsl::Tlm::PACKET_COMMAND )
	{
    	    temp = reinterpret_cast<Payload_t *>( p.get_data_ptr() );
            double txtime=(temp->sender_times);
            double  rxtime=sc_core::sc_time_stamp().to_double() ;
            std::cout << "Collector name: "<<name()<<" RECEIVED data: " << temp->Temperature << ", size: " << p.get_data_length()<<" delay "<< (rxtime-txtime)*1e-12<<std::endl  ;

	}
	
    else
    {
        // ERROR.
        SCNSL_TRACE_ERROR( 1, "Invalid PACKET_COMMAND." );

        // Just to avoid compiler warnings:
        t = sc_core::sc_time_stamp();
    }
}




