

#include <sstream>
#include "MyCollector_t.hh"

// ////////////////////////////////////////////////////////////////
// Constructor and destructor.
// ////////////////////////////////////////////////////////////////



typedef struct P_t
{
   unsigned int src_id;			//4
   double sender_times;        //8
   int temperature;			 
} Payload_t;

Payload_t arrivedPacket;

MyCollector_t::MyCollector_t( const sc_core::sc_module_name modulename,
                    const task_id_t id,
                    Scnsl::Core::Node_t * n,
                    const size_t proxies )
    throw ():
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )
    // Fields:
{  
 

}


MyCollector_t::~MyCollector_t()
    throw ()
{
    // Nothing to do.
}

// ////////////////////////////////////////////////////////////////
// Inherited interface methods.
// ////////////////////////////////////////////////////////////////


void MyCollector_t::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t )
{
    Payload_t * temp;
    if( p.get_command() == Scnsl::Tlm::PACKET_COMMAND )
    {
        temp = reinterpret_cast<Payload_t *>( p.get_data_ptr() );
        arrivedPacket.sender_times = temp->sender_times;
        arrivedPacket.src_id = temp->src_id;
        arrivedPacket.temperature = temp->temperature;
        std::cout << "Task name: "<<name()<<" RECEIVED data: " << temp->temperature << ", size: " << p.get_data_length()<<" delay "<< (sc_core::sc_time_stamp().to_double()-temp->sender_times)*1e-12<<std::endl  ;
     }
    else
        {
          // ERROR.
          SCNSL_TRACE_ERROR( 1, "Invalid PACKET_COMMAND." );
          // Just to avoid compiler warnings:
          t = sc_core::sc_time_stamp();
        }
}

